<?php

/* ***********************************************************
 * This file was automatically generated on 2017-01-25.      *
 *                                                           *
 * PHP Bindings Version 2.1.11                               *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

namespace Tinkerforge;

require_once(__DIR__ . '/IPConnection.php');

/**
 * Measures temperature with thermocouples
 */
class BrickletThermocouple extends Device
{

    /**
     * This callback is triggered periodically with the period that is set by
     * BrickletThermocouple::setTemperatureCallbackPeriod(). The parameter is the temperature
     * of the thermocouple.
     * 
     * BrickletThermocouple::CALLBACK_TEMPERATURE is only triggered if the temperature has changed since the
     * last triggering.
     */
    const CALLBACK_TEMPERATURE = 8;

    /**
     * This callback is triggered when the threshold as set by
     * BrickletThermocouple::setTemperatureCallbackThreshold() is reached.
     * The parameter is the temperature of the thermocouple.
     * 
     * If the threshold keeps being reached, the callback is triggered periodically
     * with the period as set by BrickletThermocouple::setDebouncePeriod().
     */
    const CALLBACK_TEMPERATURE_REACHED = 9;

    /**
     * This Callback is triggered every time the error state changes 
     * (see func:`GetErrorStatus`).
     */
    const CALLBACK_ERROR_STATE = 13;


    /**
     * @internal
     */
    const FUNCTION_GET_TEMPERATURE = 1;

    /**
     * @internal
     */
    const FUNCTION_SET_TEMPERATURE_CALLBACK_PERIOD = 2;

    /**
     * @internal
     */
    const FUNCTION_GET_TEMPERATURE_CALLBACK_PERIOD = 3;

    /**
     * @internal
     */
    const FUNCTION_SET_TEMPERATURE_CALLBACK_THRESHOLD = 4;

    /**
     * @internal
     */
    const FUNCTION_GET_TEMPERATURE_CALLBACK_THRESHOLD = 5;

    /**
     * @internal
     */
    const FUNCTION_SET_DEBOUNCE_PERIOD = 6;

    /**
     * @internal
     */
    const FUNCTION_GET_DEBOUNCE_PERIOD = 7;

    /**
     * @internal
     */
    const FUNCTION_SET_CONFIGURATION = 10;

    /**
     * @internal
     */
    const FUNCTION_GET_CONFIGURATION = 11;

    /**
     * @internal
     */
    const FUNCTION_GET_ERROR_STATE = 12;

    /**
     * @internal
     */
    const FUNCTION_GET_IDENTITY = 255;

    const THRESHOLD_OPTION_OFF = 'x';
    const THRESHOLD_OPTION_OUTSIDE = 'o';
    const THRESHOLD_OPTION_INSIDE = 'i';
    const THRESHOLD_OPTION_SMALLER = '<';
    const THRESHOLD_OPTION_GREATER = '>';
    const AVERAGING_1 = 1;
    const AVERAGING_2 = 2;
    const AVERAGING_4 = 4;
    const AVERAGING_8 = 8;
    const AVERAGING_16 = 16;
    const TYPE_B = 0;
    const TYPE_E = 1;
    const TYPE_J = 2;
    const TYPE_K = 3;
    const TYPE_N = 4;
    const TYPE_R = 5;
    const TYPE_S = 6;
    const TYPE_T = 7;
    const TYPE_G8 = 8;
    const TYPE_G32 = 9;
    const FILTER_OPTION_50HZ = 0;
    const FILTER_OPTION_60HZ = 1;

    const DEVICE_IDENTIFIER = 266;

    const DEVICE_DISPLAY_NAME = "Thermocouple Bricklet";

    /**
     * Creates an object with the unique device ID $uid. This object can
     * then be added to the IP connection.
     *
     * @param string $uid
     */
    public function __construct($uid, $ipcon)
    {
        parent::__construct($uid, $ipcon);

        $this->apiVersion = array(2, 0, 0);

        $this->responseExpected[self::FUNCTION_GET_TEMPERATURE] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_TEMPERATURE_CALLBACK_PERIOD] = self::RESPONSE_EXPECTED_TRUE;
        $this->responseExpected[self::FUNCTION_GET_TEMPERATURE_CALLBACK_PERIOD] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_TEMPERATURE_CALLBACK_THRESHOLD] = self::RESPONSE_EXPECTED_TRUE;
        $this->responseExpected[self::FUNCTION_GET_TEMPERATURE_CALLBACK_THRESHOLD] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_DEBOUNCE_PERIOD] = self::RESPONSE_EXPECTED_TRUE;
        $this->responseExpected[self::FUNCTION_GET_DEBOUNCE_PERIOD] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::CALLBACK_TEMPERATURE] = self::RESPONSE_EXPECTED_ALWAYS_FALSE;
        $this->responseExpected[self::CALLBACK_TEMPERATURE_REACHED] = self::RESPONSE_EXPECTED_ALWAYS_FALSE;
        $this->responseExpected[self::FUNCTION_SET_CONFIGURATION] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_GET_CONFIGURATION] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_GET_ERROR_STATE] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::CALLBACK_ERROR_STATE] = self::RESPONSE_EXPECTED_ALWAYS_FALSE;
        $this->responseExpected[self::FUNCTION_GET_IDENTITY] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;

        $this->callbackWrappers[self::CALLBACK_TEMPERATURE] = 'callbackWrapperTemperature';
        $this->callbackWrappers[self::CALLBACK_TEMPERATURE_REACHED] = 'callbackWrapperTemperatureReached';
        $this->callbackWrappers[self::CALLBACK_ERROR_STATE] = 'callbackWrapperErrorState';
    }

    /**
     * @internal
     * @param string $header
     * @param string $data
     */
    public function handleCallback($header, $data)
    {
        call_user_func(array($this, $this->callbackWrappers[$header['functionID']]), $data);
    }

    /**
     * Returns the temperature of the thermocouple. The value is given in °C/100,
     * e.g. a value of 4223 means that a temperature of 42.23 °C is measured.
     * 
     * If you want to get the temperature periodically, it is recommended 
     * to use the callback BrickletThermocouple::CALLBACK_TEMPERATURE and set the period with 
     * BrickletThermocouple::setTemperatureCallbackPeriod().
     * 
     * 
     * @return int
     */
    public function getTemperature()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_TEMPERATURE, $payload);

        $payload = unpack('V1temperature', $data);

        return IPConnection::fixUnpackedInt32($payload, 'temperature');
    }

    /**
     * Sets the period in ms with which the BrickletThermocouple::CALLBACK_TEMPERATURE callback is triggered
     * periodically. A value of 0 turns the callback off.
     * 
     * BrickletThermocouple::CALLBACK_TEMPERATURE is only triggered if the temperature has changed since the
     * last triggering.
     * 
     * The default value is 0.
     * 
     * @param int $period
     * 
     * @return void
     */
    public function setTemperatureCallbackPeriod($period)
    {
        $payload = '';
        $payload .= pack('V', $period);

        $this->sendRequest(self::FUNCTION_SET_TEMPERATURE_CALLBACK_PERIOD, $payload);
    }

    /**
     * Returns the period as set by BrickletThermocouple::setTemperatureCallbackPeriod().
     * 
     * 
     * @return int
     */
    public function getTemperatureCallbackPeriod()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_TEMPERATURE_CALLBACK_PERIOD, $payload);

        $payload = unpack('V1period', $data);

        return IPConnection::fixUnpackedUInt32($payload, 'period');
    }

    /**
     * Sets the thresholds for the BrickletThermocouple::CALLBACK_TEMPERATURE_REACHED callback. 
     * 
     * The following options are possible:
     * 
     * <code>
     *  "Option", "Description"
     * 
     *  "'x'",    "Callback is turned off"
     *  "'o'",    "Callback is triggered when the temperature is *outside* the min and max values"
     *  "'i'",    "Callback is triggered when the temperature is *inside* the min and max values"
     *  "'<'",    "Callback is triggered when the temperature is smaller than the min value (max is ignored)"
     *  "'>'",    "Callback is triggered when the temperature is greater than the min value (max is ignored)"
     * </code>
     * 
     * The default value is ('x', 0, 0).
     * 
     * @param string $option
     * @param int $min
     * @param int $max
     * 
     * @return void
     */
    public function setTemperatureCallbackThreshold($option, $min, $max)
    {
        $payload = '';
        $payload .= pack('c', ord($option));
        $payload .= pack('V', $min);
        $payload .= pack('V', $max);

        $this->sendRequest(self::FUNCTION_SET_TEMPERATURE_CALLBACK_THRESHOLD, $payload);
    }

    /**
     * Returns the threshold as set by BrickletThermocouple::setTemperatureCallbackThreshold().
     * 
     * 
     * @return array
     */
    public function getTemperatureCallbackThreshold()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_TEMPERATURE_CALLBACK_THRESHOLD, $payload);

        $payload = unpack('c1option/V1min/V1max', $data);

        $result['option'] = chr($payload['option']);
        $result['min'] = IPConnection::fixUnpackedInt32($payload, 'min');
        $result['max'] = IPConnection::fixUnpackedInt32($payload, 'max');

        return $result;
    }

    /**
     * Sets the period in ms with which the threshold callback
     * 
     * * BrickletThermocouple::CALLBACK_TEMPERATURE_REACHED
     * 
     * is triggered, if the threshold
     * 
     * * BrickletThermocouple::setTemperatureCallbackThreshold()
     * 
     * keeps being reached.
     * 
     * The default value is 100.
     * 
     * @param int $debounce
     * 
     * @return void
     */
    public function setDebouncePeriod($debounce)
    {
        $payload = '';
        $payload .= pack('V', $debounce);

        $this->sendRequest(self::FUNCTION_SET_DEBOUNCE_PERIOD, $payload);
    }

    /**
     * Returns the debounce period as set by BrickletThermocouple::setDebouncePeriod().
     * 
     * 
     * @return int
     */
    public function getDebouncePeriod()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_DEBOUNCE_PERIOD, $payload);

        $payload = unpack('V1debounce', $data);

        return IPConnection::fixUnpackedUInt32($payload, 'debounce');
    }

    /**
     * You can configure averaging size, thermocouple type and frequency
     * filtering.
     * 
     * Available averaging sizes are 1, 2, 4, 8 and 16 samples.
     * 
     * As thermocouple type you can use B, E, J, K, N, R, S and T. If you have a
     * different thermocouple or a custom thermocouple you can also use
     * G8 and G32. With these types the returned value will not be in °C/100,
     * it will be calculated by the following formulas:
     * 
     * * G8: ``value = 8 * 1.6 * 2^17 * Vin``
     * * G32: ``value = 32 * 1.6 * 2^17 * Vin``
     * 
     * where Vin is the thermocouple input voltage.
     * 
     * The frequency filter can be either configured to 50Hz or to 60Hz. You should
     * configure it according to your utility frequency.
     * 
     * The conversion time depends on the averaging and filter configuration, it can
     * be calculated as follows:
     * 
     * * 60Hz: ``time = 82 + (samples - 1) * 16.67``
     * * 50Hz: ``time = 98 + (samples - 1) * 20``
     * 
     * The default configuration is 16 samples, K type and 50Hz.
     * 
     * @param int $averaging
     * @param int $thermocouple_type
     * @param int $filter
     * 
     * @return void
     */
    public function setConfiguration($averaging, $thermocouple_type, $filter)
    {
        $payload = '';
        $payload .= pack('C', $averaging);
        $payload .= pack('C', $thermocouple_type);
        $payload .= pack('C', $filter);

        $this->sendRequest(self::FUNCTION_SET_CONFIGURATION, $payload);
    }

    /**
     * Returns the configuration as set by BrickletThermocouple::setConfiguration().
     * 
     * 
     * @return array
     */
    public function getConfiguration()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_CONFIGURATION, $payload);

        $payload = unpack('C1averaging/C1thermocouple_type/C1filter', $data);

        $result['averaging'] = $payload['averaging'];
        $result['thermocouple_type'] = $payload['thermocouple_type'];
        $result['filter'] = $payload['filter'];

        return $result;
    }

    /**
     * Returns the current error state. There are two possible errors:
     * 
     * * Over/Under Voltage and
     * * Open Circuit.
     * 
     * Over/Under Voltage happens for voltages below 0V or above 3.3V. In this case
     * it is very likely that your thermocouple is defective. An Open Circuit error
     * indicates that there is no thermocouple connected.
     * 
     * You can use the func:`ErrorState` callback to automatically get triggered
     * when the error state changes.
     * 
     * 
     * @return array
     */
    public function getErrorState()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_ERROR_STATE, $payload);

        $payload = unpack('C1over_under/C1open_circuit', $data);

        $result['over_under'] = (bool)$payload['over_under'];
        $result['open_circuit'] = (bool)$payload['open_circuit'];

        return $result;
    }

    /**
     * Returns the UID, the UID where the Bricklet is connected to, 
     * the position, the hardware and firmware version as well as the
     * device identifier.
     * 
     * The position can be 'a', 'b', 'c' or 'd'.
     * 
     * The device identifier numbers can be found :ref:`here <device_identifier>`.
     * |device_identifier_constant|
     * 
     * 
     * @return array
     */
    public function getIdentity()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_IDENTITY, $payload);

        $payload = unpack('c8uid/c8connected_uid/c1position/C3hardware_version/C3firmware_version/v1device_identifier', $data);

        $result['uid'] = IPConnection::implodeUnpackedString($payload, 'uid', 8);
        $result['connected_uid'] = IPConnection::implodeUnpackedString($payload, 'connected_uid', 8);
        $result['position'] = chr($payload['position']);
        $result['hardware_version'] = IPConnection::collectUnpackedArray($payload, 'hardware_version', 3);
        $result['firmware_version'] = IPConnection::collectUnpackedArray($payload, 'firmware_version', 3);
        $result['device_identifier'] = $payload['device_identifier'];

        return $result;
    }

    /**
     * Registers a callback with ID $id to the callable $callback.
     *
     * @param int $id
     * @param callable $callback
     * @param mixed $user_data
     *
     * @return void
     */
    public function registerCallback($id, $callback, $user_data = NULL)
    {
        if (!is_callable($callback)) {
            throw new \Exception('Callback function is not callable');
        }

        $this->registeredCallbacks[$id] = $callback;
        $this->registeredCallbackUserData[$id] = $user_data;
    }

    /**
     * @internal
     * @param string $data
     */
    public function callbackWrapperTemperature($data)
    {
        $result = array();
        $payload = unpack('V1temperature', $data);

        array_push($result, IPConnection::fixUnpackedInt32($payload, 'temperature'));
        array_push($result, $this->registeredCallbackUserData[self::CALLBACK_TEMPERATURE]);

        call_user_func_array($this->registeredCallbacks[self::CALLBACK_TEMPERATURE], $result);
    }

    /**
     * @internal
     * @param string $data
     */
    public function callbackWrapperTemperatureReached($data)
    {
        $result = array();
        $payload = unpack('V1temperature', $data);

        array_push($result, IPConnection::fixUnpackedInt32($payload, 'temperature'));
        array_push($result, $this->registeredCallbackUserData[self::CALLBACK_TEMPERATURE_REACHED]);

        call_user_func_array($this->registeredCallbacks[self::CALLBACK_TEMPERATURE_REACHED], $result);
    }

    /**
     * @internal
     * @param string $data
     */
    public function callbackWrapperErrorState($data)
    {
        $result = array();
        $payload = unpack('C1over_under/C1open_circuit', $data);

        array_push($result, (bool)$payload['over_under']);
        array_push($result, (bool)$payload['open_circuit']);
        array_push($result, $this->registeredCallbackUserData[self::CALLBACK_ERROR_STATE]);

        call_user_func_array($this->registeredCallbacks[self::CALLBACK_ERROR_STATE], $result);
    }
}

?>
